/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Types_STUB_DEFAULT_HPP_
#define V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Types_STUB_DEFAULT_HPP_

#include <v1/commonapi/telux/common/CommonDefinesStubDefault.hpp>

#include <CommonAPI/Export.hpp>

#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesStub.hpp>
#include <cassert>
#include <sstream>

# if defined(_MSC_VER)
#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif
# endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

/**
 * Provides a default implementation for Cv2xRadioTypesStubRemoteEvent and
 * Cv2xRadioTypesStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class COMMONAPI_EXPORT_CLASS_EXPLICIT Cv2xRadioTypesStubDefault
    : public virtual Cv2xRadioTypesStub,
      public virtual ::v1::commonapi::telux::common::CommonDefinesStubDefault {
public:
    COMMONAPI_EXPORT Cv2xRadioTypesStubDefault()
        : remoteEventHandler_(this),
          interfaceVersion_(Cv2xRadioTypes::getInterfaceVersion()) {
    }

    COMMONAPI_EXPORT const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return interfaceVersion_;
    }

    COMMONAPI_EXPORT Cv2xRadioTypesStubRemoteEvent* initStubAdapter(const std::shared_ptr< Cv2xRadioTypesStubAdapter> &_adapter) {
        CommonDefinesStubDefault::initStubAdapter(_adapter);
        CommonAPI::Stub<Cv2xRadioTypesStubAdapter, Cv2xRadioTypesStubRemoteEvent>::stubAdapter_ = _adapter;
        return &remoteEventHandler_;
    }



protected:
    class COMMONAPI_EXPORT_CLASS_EXPLICIT RemoteEventHandler: public virtual Cv2xRadioTypesStubRemoteEvent, public virtual CommonDefinesStubDefault::RemoteEventHandler {
    public:
        COMMONAPI_EXPORT RemoteEventHandler(Cv2xRadioTypesStubDefault *_defaultStub)
            : ::v1::commonapi::telux::common::CommonDefinesStubDefault::RemoteEventHandler(_defaultStub),
              defaultStub_(_defaultStub) {
        }


    private:
        Cv2xRadioTypesStubDefault *defaultStub_;
    };
protected:
    Cv2xRadioTypesStubDefault::RemoteEventHandler remoteEventHandler_;

private:


    CommonAPI::Version interfaceVersion_;
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Types_STUB_DEFAULT
